## Replication Package

This document describes the structure of the replication package. For each 
folder, please read the README.md to get more information about each module.

- The `malicious_dependencies_database` folder includes the scripts created to build the database of malicious dependencis for Puppet. The resulting database can be observed in `malicious_dependencies_database/config`. There is a .json file for each vulnerable software package. Inside of each .json file, you will see the version number and respective CVEs.

- The `pre-screening` folder includes a pdf with the questions used to perform the pre-screening described in section 5. Results are available inside of the folder `study`.

- The `puppet-lint-infrasecure` folder integrates the linter codebase. Please read the `TOOL.md` to learn how to install and run the tool. There is an example available inside of `puppet-lint-infrasecure/files/test.pp`. If you want to run it over other Puppet scripts, you can try any of the scripts available `study/puppet-files`.

- The `study` folder provides all the different datasets, feedback and final oracles used in this study.